require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_DESC_H)) {
    eval 'sub __ARCH_DESC_H {1;}' unless defined(&__ARCH_DESC_H);
    require 'asm/ldt.ph';
    require 'asm/segment.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/preempt.ph';
	require 'linux/smp.ph';
	require 'asm/mmu.ph';
	eval 'sub load_TR_desc () {
	    eval q( &__asm__  &__volatile__(\\"ltr %%ax\\"::\\"a\\" ( &GDT_ENTRY_TSS*8)));
	}' unless defined(&load_TR_desc);
	eval 'sub load_LDT_desc () {
	    eval q( &__asm__  &__volatile__(\\"lldt %%ax\\"::\\"a\\" ( &GDT_ENTRY_LDT*8)));
	}' unless defined(&load_LDT_desc);
	eval 'sub _set_tssldt_desc {
	    local($n,$addr,$limit,$type) = @_;
    	    eval q( &__asm__  &__volatile__ (\\"movw %w3,0(%2)\\\\n\\\\t\\" \\"movw %%ax,2(%2)\\\\n\\\\t\\" \\"rorl $16,%%eax\\\\n\\\\t\\" \\"movb %%al,4(%2)\\\\n\\\\t\\" \\"movb %4,5(%2)\\\\n\\\\t\\" \\"movb $0,6(%2)\\\\n\\\\t\\" \\"movb %%ah,7(%2)\\\\n\\\\t\\" \\"rorl $16,%%eax\\" : \\"=m\\"(*($n)) : \\"a\\" ($addr), \\"r\\"($n), \\"ir\\"($limit), \\"i\\"($type)));
	}' unless defined(&_set_tssldt_desc);
	eval 'sub set_tss_desc {
	    local($cpu,$addr) = @_;
    	    eval q( &__set_tss_desc($cpu,  &GDT_ENTRY_TSS, $addr));
	}' unless defined(&set_tss_desc);
	eval 'sub LDT_entry_a {
	    local($info) = @_;
    	    eval q((((($info)-> &base_addr & 0xffff) << 16) | (($info)-> &limit & 0xffff)));
	}' unless defined(&LDT_entry_a);
	eval 'sub LDT_entry_b {
	    local($info) = @_;
    	    eval q(((($info)-> &base_addr & 0xff000000) | ((($info)-> &base_addr & 0xff0000) >> 16) | (($info)-> &limit & 0xf0000) | ((($info)-> &read_exec_only ^ 1) << 9) | (($info)-> &contents << 10) | ((($info)-> &seg_not_present ^ 1) << 15) | (($info)-> &seg_32bit << 22) | (($info)-> &limit_in_pages << 23) | (($info)-> &useable << 20) | 0x7000));
	}' unless defined(&LDT_entry_b);
	eval 'sub LDT_empty {
	    local($info) = @_;
    	    eval q(( ($info)-> &base_addr == 0 && ($info)-> &limit == 0 && ($info)-> &contents == 0 && ($info)-> &read_exec_only == 1 && ($info)-> &seg_32bit == 0 && ($info)-> &limit_in_pages == 0 && ($info)-> &seg_not_present == 1 && ($info)-> &useable == 0));
	}' unless defined(&LDT_empty);
	if((defined(&TLS_SIZE) ? &TLS_SIZE : 0) != 24) {
	    die("update\ this\ code\.");
	}
	eval 'sub C {
	    local($i) = @_;
    	    eval q( $cpu_gdt_table[ &cpu][ &GDT_ENTRY_TLS_MIN + $i] =  ($t->{tls_array[$i]}));
	}' unless defined(&C);
	undef(&C) if defined(&C);
    }
}
1;
