require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PGTABLE_H)) {
    eval 'sub _I386_PGTABLE_H {1;}' unless defined(&_I386_PGTABLE_H);
    require 'linux/config.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/processor.ph';
	require 'asm/fixmap.ph';
	require 'linux/threads.ph';
	unless(defined(&_I386_BITOPS_H)) {
	    require 'asm/bitops.ph';
	}
	require 'linux/slab.ph';
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	eval 'sub ZERO_PAGE {
	    local($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page)));
	}' unless defined(&ZERO_PAGE);
    }
    unless(defined(&__ASSEMBLY__)) {
	if(defined(&CONFIG_X86_PAE)) {
	    require 'asm/pgtable-3level.ph';
	} else {
	    require 'asm/pgtable-2level.ph';
	}
    }
    eval 'sub PMD_SIZE {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SIZE {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub USER_PTRS_PER_PGD {( &TASK_SIZE/ &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub FIRST_USER_PGD_NR {0;}' unless defined(&FIRST_USER_PGD_NR);
    eval 'sub USER_PGD_PTRS {( &PAGE_OFFSET >>  &PGDIR_SHIFT);}' unless defined(&USER_PGD_PTRS);
    eval 'sub KERNEL_PGD_PTRS {( &PTRS_PER_PGD- &USER_PGD_PTRS);}' unless defined(&KERNEL_PGD_PTRS);
    eval 'sub TWOLEVEL_PGDIR_SHIFT {22;}' unless defined(&TWOLEVEL_PGDIR_SHIFT);
    eval 'sub BOOT_USER_PGD_PTRS {( &__PAGE_OFFSET >>  &TWOLEVEL_PGDIR_SHIFT);}' unless defined(&BOOT_USER_PGD_PTRS);
    eval 'sub BOOT_KERNEL_PGD_PTRS {(1024- &BOOT_USER_PGD_PTRS);}' unless defined(&BOOT_KERNEL_PGD_PTRS);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub VMALLOC_OFFSET {(8*1024*1024);}' unless defined(&VMALLOC_OFFSET);
	eval 'sub VMALLOC_START {((  &high_memory + 2* &VMALLOC_OFFSET-1) & ~( &VMALLOC_OFFSET-1));}' unless defined(&VMALLOC_START);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub VMALLOC_END {( &PKMAP_BASE-2* &PAGE_SIZE);}' unless defined(&VMALLOC_END);
	} else {
	    eval 'sub VMALLOC_END {( &FIXADDR_START-2* &PAGE_SIZE);}' unless defined(&VMALLOC_END);
	}
	eval 'sub _PAGE_BIT_PRESENT {0;}' unless defined(&_PAGE_BIT_PRESENT);
	eval 'sub _PAGE_BIT_RW {1;}' unless defined(&_PAGE_BIT_RW);
	eval 'sub _PAGE_BIT_USER {2;}' unless defined(&_PAGE_BIT_USER);
	eval 'sub _PAGE_BIT_PWT {3;}' unless defined(&_PAGE_BIT_PWT);
	eval 'sub _PAGE_BIT_PCD {4;}' unless defined(&_PAGE_BIT_PCD);
	eval 'sub _PAGE_BIT_ACCESSED {5;}' unless defined(&_PAGE_BIT_ACCESSED);
	eval 'sub _PAGE_BIT_DIRTY {6;}' unless defined(&_PAGE_BIT_DIRTY);
	eval 'sub _PAGE_BIT_PSE {7;}' unless defined(&_PAGE_BIT_PSE);
	eval 'sub _PAGE_BIT_GLOBAL {8;}' unless defined(&_PAGE_BIT_GLOBAL);
	eval 'sub _PAGE_PRESENT {0x1;}' unless defined(&_PAGE_PRESENT);
	eval 'sub _PAGE_RW {0x2;}' unless defined(&_PAGE_RW);
	eval 'sub _PAGE_USER {0x4;}' unless defined(&_PAGE_USER);
	eval 'sub _PAGE_PWT {0x8;}' unless defined(&_PAGE_PWT);
	eval 'sub _PAGE_PCD {0x10;}' unless defined(&_PAGE_PCD);
	eval 'sub _PAGE_ACCESSED {0x20;}' unless defined(&_PAGE_ACCESSED);
	eval 'sub _PAGE_DIRTY {0x40;}' unless defined(&_PAGE_DIRTY);
	eval 'sub _PAGE_PSE {0x80;}' unless defined(&_PAGE_PSE);
	eval 'sub _PAGE_GLOBAL {0x100;}' unless defined(&_PAGE_GLOBAL);
	eval 'sub _PAGE_FILE {0x40;}' unless defined(&_PAGE_FILE);
	eval 'sub _PAGE_PROTNONE {0x80;}' unless defined(&_PAGE_PROTNONE);
	eval 'sub _PAGE_TABLE {( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_USER |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_TABLE);
	eval 'sub _KERNPG_TABLE {( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_KERNPG_TABLE);
	eval 'sub _PAGE_CHG_MASK {( &PTE_MASK |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_CHG_MASK);
	eval 'sub PAGE_NONE { &__pgprot( &_PAGE_PROTNONE |  &_PAGE_ACCESSED);}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_SHARED { &__pgprot( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_USER |  &_PAGE_ACCESSED);}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_COPY { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_ACCESSED);}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_READONLY { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_ACCESSED);}' unless defined(&PAGE_READONLY);
	eval 'sub _PAGE_KERNEL {( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_DIRTY |  &_PAGE_ACCESSED);}' unless defined(&_PAGE_KERNEL);
	eval 'sub __PAGE_KERNEL_RO {( &__PAGE_KERNEL & ~ &_PAGE_RW);}' unless defined(&__PAGE_KERNEL_RO);
	eval 'sub __PAGE_KERNEL_NOCACHE {( &__PAGE_KERNEL |  &_PAGE_PCD);}' unless defined(&__PAGE_KERNEL_NOCACHE);
	eval 'sub __PAGE_KERNEL_LARGE {( &__PAGE_KERNEL |  &_PAGE_PSE);}' unless defined(&__PAGE_KERNEL_LARGE);
	eval 'sub PAGE_KERNEL { &__pgprot( &__PAGE_KERNEL);}' unless defined(&PAGE_KERNEL);
	eval 'sub PAGE_KERNEL_RO { &__pgprot( &__PAGE_KERNEL_RO);}' unless defined(&PAGE_KERNEL_RO);
	eval 'sub PAGE_KERNEL_NOCACHE { &__pgprot( &__PAGE_KERNEL_NOCACHE);}' unless defined(&PAGE_KERNEL_NOCACHE);
	eval 'sub PAGE_KERNEL_LARGE { &__pgprot( &__PAGE_KERNEL_LARGE);}' unless defined(&PAGE_KERNEL_LARGE);
	eval 'sub __P000 { &PAGE_NONE;}' unless defined(&__P000);
	eval 'sub __P001 { &PAGE_READONLY;}' unless defined(&__P001);
	eval 'sub __P010 { &PAGE_COPY;}' unless defined(&__P010);
	eval 'sub __P011 { &PAGE_COPY;}' unless defined(&__P011);
	eval 'sub __P100 { &PAGE_READONLY;}' unless defined(&__P100);
	eval 'sub __P101 { &PAGE_READONLY;}' unless defined(&__P101);
	eval 'sub __P110 { &PAGE_COPY;}' unless defined(&__P110);
	eval 'sub __P111 { &PAGE_COPY;}' unless defined(&__P111);
	eval 'sub __S000 { &PAGE_NONE;}' unless defined(&__S000);
	eval 'sub __S001 { &PAGE_READONLY;}' unless defined(&__S001);
	eval 'sub __S010 { &PAGE_SHARED;}' unless defined(&__S010);
	eval 'sub __S011 { &PAGE_SHARED;}' unless defined(&__S011);
	eval 'sub __S100 { &PAGE_READONLY;}' unless defined(&__S100);
	eval 'sub __S101 { &PAGE_READONLY;}' unless defined(&__S101);
	eval 'sub __S110 { &PAGE_SHARED;}' unless defined(&__S110);
	eval 'sub __S111 { &PAGE_SHARED;}' unless defined(&__S111);
	undef(&TEST_VERIFY_AREA) if defined(&TEST_VERIFY_AREA);
	eval 'sub pte_present {
	    local($x) = @_;
    	    eval q((($x). &pte_low & ( &_PAGE_PRESENT |  &_PAGE_PROTNONE)));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    local($xp) = @_;
    	    eval q( &do {  &set_pte($xp,  &__pte(0)); }  &while (0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    local($x) = @_;
    	    eval q((! &pmd_val($x)));
	}' unless defined(&pmd_none);
	eval 'sub pmd_present {
	    local($x) = @_;
    	    eval q(( &pmd_val($x) &  &_PAGE_PRESENT));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    local($xp) = @_;
    	    eval q( &do {  &set_pmd($xp,  &__pmd(0)); }  &while (0));
	}' unless defined(&pmd_clear);
	eval 'sub pmd_bad {
	    local($x) = @_;
    	    eval q((( &pmd_val($x) & (~ &PAGE_MASK & ~ &_PAGE_USER)) !=  &_KERNPG_TABLE));
	}' unless defined(&pmd_bad);
	eval 'sub pages_to_mb {
	    local($x) = @_;
    	    eval q((($x) >> (20- &PAGE_SHIFT)));
	}' unless defined(&pages_to_mb);
	eval 'sub pgprot_noncached {
	    local($prot) = @_;
    	    eval q((( ($boot_cpu_data->{x86}) > 3) ? ( &__pgprot( &pgprot_val($prot) |  &_PAGE_PCD |  &_PAGE_PWT)) : ($prot)));
	}' unless defined(&pgprot_noncached);
	eval 'sub mk_pte {
	    local($page, $pgprot) = @_;
    	    eval q( &pfn_pte( &page_to_pfn($page), ($pgprot)));
	}' unless defined(&mk_pte);
	eval 'sub mk_pte_huge {
	    local($entry) = @_;
    	    eval q((($entry). &pte_low |=  &_PAGE_PRESENT |  &_PAGE_PSE));
	}' unless defined(&mk_pte_huge);
	eval 'sub page_pte {
	    local($page) = @_;
    	    eval q( &page_pte_prot($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub pmd_page_kernel {
	    local($pmd) = @_;
    	    eval q((  &__va( &pmd_val($pmd) &  &PAGE_MASK)));
	}' unless defined(&pmd_page_kernel);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub pmd_page {
	        local($pmd) = @_;
    		eval q(( &pfn_to_page( &pmd_val($pmd) >>  &PAGE_SHIFT)));
	    }' unless defined(&pmd_page);
	}
	eval 'sub pmd_large {
	    local($pmd) = @_;
    	    eval q((( &pmd_val($pmd) & ( &_PAGE_PSE| &_PAGE_PRESENT)) == ( &_PAGE_PSE| &_PAGE_PRESENT)));
	}' unless defined(&pmd_large);
	eval 'sub pgd_index {
	    local($address) = @_;
    	    eval q(((($address) >>  &PGDIR_SHIFT) & ( &PTRS_PER_PGD-1)));
	}' unless defined(&pgd_index);
	eval 'sub pgd_offset {
	    local($mm, $address) = @_;
    	    eval q((($mm)-> &pgd+ &pgd_index($address)));
	}' unless defined(&pgd_offset);
	eval 'sub pgd_offset_k {
	    local($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pmd_index {
	    local($address) = @_;
    	    eval q(((($address) >>  &PMD_SHIFT) & ( &PTRS_PER_PMD-1)));
	}' unless defined(&pmd_index);
	eval 'sub pte_index {
	    local($address) = @_;
    	    eval q(((($address) >>  &PAGE_SHIFT) & ( &PTRS_PER_PTE - 1)));
	}' unless defined(&pte_index);
	eval 'sub pte_offset_kernel {
	    local($dir, $address) = @_;
    	    eval q((  &pmd_page_kernel(*($dir)) +  &pte_index($address)));
	}' unless defined(&pte_offset_kernel);
	if(defined( &CONFIG_HIGHPTE)) {
	    eval 'sub pte_offset_map {
	        local($dir, $address) = @_;
    		eval q(( &kmap_atomic( &pmd_page(*($dir)), &KM_PTE0) +  &pte_index($address)));
	    }' unless defined(&pte_offset_map);
	    eval 'sub pte_offset_map_nested {
	        local($dir, $address) = @_;
    		eval q(( &kmap_atomic( &pmd_page(*($dir)), &KM_PTE1) +  &pte_index($address)));
	    }' unless defined(&pte_offset_map_nested);
	    eval 'sub pte_unmap {
	        local($pte) = @_;
    		eval q( &kunmap_atomic($pte,  &KM_PTE0));
	    }' unless defined(&pte_unmap);
	    eval 'sub pte_unmap_nested {
	        local($pte) = @_;
    		eval q( &kunmap_atomic($pte,  &KM_PTE1));
	    }' unless defined(&pte_unmap_nested);
	} else {
	    eval 'sub pte_offset_map {
	        local($dir, $address) = @_;
    		eval q(( &page_address( &pmd_page(*($dir))) +  &pte_index($address)));
	    }' unless defined(&pte_offset_map);
	    eval 'sub pte_offset_map_nested {
	        local($dir, $address) = @_;
    		eval q( &pte_offset_map($dir, $address));
	    }' unless defined(&pte_offset_map_nested);
	    eval 'sub pte_unmap {
	        local($pte) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pte_unmap);
	    eval 'sub pte_unmap_nested {
	        local($pte) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pte_unmap_nested);
	}
	if(defined( &CONFIG_HIGHPTE)  && defined( &CONFIG_HIGHMEM4G)) {
	}
	if(defined( &CONFIG_HIGHPTE)  && defined( &CONFIG_HIGHMEM64G)) {
	}
	if(!defined( &CONFIG_HIGHPTE)) {
	}
	eval 'sub update_mmu_cache {
	    local($vma,$address,$pte) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&update_mmu_cache);
	eval 'sub __swp_type {
	    local($x) = @_;
    	    eval q(((($x). &val >> 1) & 0x1f));
	}' unless defined(&__swp_type);
	eval 'sub __swp_offset {
	    local($x) = @_;
    	    eval q((($x). &val >> 8));
	}' unless defined(&__swp_offset);
	eval 'sub __swp_entry {
	    local($type, $offset) = @_;
    	    eval q((( &swp_entry_t) { (($type) << 1) | (($offset) << 8) }));
	}' unless defined(&__swp_entry);
	eval 'sub __pte_to_swp_entry {
	    local($pte) = @_;
    	    eval q((( &swp_entry_t) { ($pte). &pte_low }));
	}' unless defined(&__pte_to_swp_entry);
	eval 'sub __swp_entry_to_pte {
	    local($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&__swp_entry_to_pte);
    }
    unless(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub kern_addr_valid {
	    local($addr) = @_;
    	    eval q((1));
	}' unless defined(&kern_addr_valid);
    }
    eval 'sub io_remap_page_range { &remap_page_range;}' unless defined(&io_remap_page_range);
    eval 'sub __HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG {1;}' unless defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG);
    eval 'sub __HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY {1;}' unless defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY);
    eval 'sub __HAVE_ARCH_PTEP_GET_AND_CLEAR {1;}' unless defined(&__HAVE_ARCH_PTEP_GET_AND_CLEAR);
    eval 'sub __HAVE_ARCH_PTEP_SET_WRPROTECT {1;}' unless defined(&__HAVE_ARCH_PTEP_SET_WRPROTECT);
    eval 'sub __HAVE_ARCH_PTEP_MKDIRTY {1;}' unless defined(&__HAVE_ARCH_PTEP_MKDIRTY);
    eval 'sub __HAVE_ARCH_PTE_SAME {1;}' unless defined(&__HAVE_ARCH_PTE_SAME);
    require 'asm-generic/pgtable.ph';
}
1;
