require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_ACPI_H)) {
    eval 'sub _ASM_ACPI_H {1;}' unless defined(&_ASM_ACPI_H);
    if(defined(&__KERNEL__)) {
	eval 'sub COMPILER_DEPENDENT_INT64 {\'long long\';}' unless defined(&COMPILER_DEPENDENT_INT64);
	eval 'sub COMPILER_DEPENDENT_UINT64 {\'unsigned long long\';}' unless defined(&COMPILER_DEPENDENT_UINT64);
	eval 'sub ACPI_SYSTEM_XFACE {1;}' unless defined(&ACPI_SYSTEM_XFACE);
	eval 'sub ACPI_EXTERNAL_XFACE {1;}' unless defined(&ACPI_EXTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_XFACE {1;}' unless defined(&ACPI_INTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_VAR_XFACE {1;}' unless defined(&ACPI_INTERNAL_VAR_XFACE);
	eval 'sub ACPI_ASM_MACROS {1;}' unless defined(&ACPI_ASM_MACROS);
	eval 'sub BREAKPOINT3 {1;}' unless defined(&BREAKPOINT3);
	eval 'sub ACPI_DISABLE_IRQS () {
	    eval q( &local_irq_disable());
	}' unless defined(&ACPI_DISABLE_IRQS);
	eval 'sub ACPI_ENABLE_IRQS () {
	    eval q( &local_irq_enable());
	}' unless defined(&ACPI_ENABLE_IRQS);
	eval 'sub ACPI_FLUSH_CPU_CACHE () {
	    eval q( &wbinvd());
	}' unless defined(&ACPI_FLUSH_CPU_CACHE);
	eval 'sub ACPI_ACQUIRE_GLOBAL_LOCK {
	    local($GLptr, $Acq) = @_;
    	    eval q(( =  &__acpi_acquire_global_lock( $GLptr)));
	}' unless defined(&ACPI_ACQUIRE_GLOBAL_LOCK);
	eval 'sub ACPI_RELEASE_GLOBAL_LOCK {
	    local($GLptr, $Acq) = @_;
    	    eval q(( =  &__acpi_release_global_lock( $GLptr)));
	}' unless defined(&ACPI_RELEASE_GLOBAL_LOCK);
	eval 'sub ACPI_DIV_64_BY_32 {
	    local($n_hi, $n_lo, $d32, $q32, $r32) = @_;
    	    eval q( &asm(\\"divl %2;\\" :\\"=a\\"($q32), \\"=d\\"($r32) :\\"r\\"($d32), \\"0\\"($n_lo), \\"1\\"($n_hi)));
	}' unless defined(&ACPI_DIV_64_BY_32);
	eval 'sub ACPI_SHIFT_RIGHT_64 {
	    local($n_hi, $n_lo) = @_;
    	    eval q( &asm(\\"shrl   $1,%2;\\" \\"rcrl   $1,%3;\\" :\\"=r\\"($n_hi), \\"=r\\"($n_lo) :\\"0\\"($n_hi), \\"1\\"($n_lo)));
	}' unless defined(&ACPI_SHIFT_RIGHT_64);
	if(defined(&CONFIG_ACPI_BOOT)) {
	    eval 'sub FIX_ACPI_PAGES {4;}' unless defined(&FIX_ACPI_PAGES);
	} else {
	    eval 'sub acpi_lapic {0;}' unless defined(&acpi_lapic);
	    eval 'sub acpi_ioapic {0;}' unless defined(&acpi_ioapic);
	}
	if(defined(&CONFIG_ACPI_PCI)) {
	} else {
	}
	if(defined(&CONFIG_ACPI_SLEEP)) {
	}
	eval 'sub boot_cpu_physical_apicid { &boot_cpu_id;}' unless defined(&boot_cpu_physical_apicid);
	eval 'sub dmi_broken {(0);}' unless defined(&dmi_broken);
	eval 'sub BROKEN_ACPI_Sx {0x1;}' unless defined(&BROKEN_ACPI_Sx);
	eval 'sub BROKEN_INIT_AFTER_S1 {0x2;}' unless defined(&BROKEN_INIT_AFTER_S1);
    }
}
1;
