require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_DESC_H)) {
    eval 'sub __ARCH_DESC_H {1;}' unless defined(&__ARCH_DESC_H);
    require 'linux/threads.ph';
    require 'asm/ldt.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/string.ph';
	require 'asm/segment.ph';
	require 'asm/mmu.ph';
	eval("sub GATE_INTERRUPT () { 0xE; }") unless defined(&GATE_INTERRUPT);
	eval("sub GATE_TRAP () { 0xF; }") unless defined(&GATE_TRAP);
	eval("sub GATE_CALL () { 0xC; }") unless defined(&GATE_CALL);
	eval 'sub PTR_LOW {
	    local($x) = @_;
    	    eval q((($x) & 0xffff));
	}' unless defined(&PTR_LOW);
	eval 'sub PTR_MIDDLE {
	    local($x) = @_;
    	    eval q(((($x) >> 16) & 0xffff));
	}' unless defined(&PTR_MIDDLE);
	eval 'sub PTR_HIGH {
	    local($x) = @_;
    	    eval q((($x) >> 32));
	}' unless defined(&PTR_HIGH);
	eval("sub DESC_TSS () { 0x9; }") unless defined(&DESC_TSS);
	eval("sub DESC_LDT () { 0x2; }") unless defined(&DESC_LDT);
	eval 'sub load_TR_desc () {
	    eval q( &asm  &volatile(\\"ltr %w0\\"::\\"r\\" ( &GDT_ENTRY_TSS*8)));
	}' unless defined(&load_TR_desc);
	eval 'sub load_LDT_desc () {
	    eval q( &asm  &volatile(\\"lldt %w0\\"::\\"r\\" ( &GDT_ENTRY_LDT*8)));
	}' unless defined(&load_LDT_desc);
	eval 'sub clear_LDT () {
	    eval q( &asm  &volatile(\\"lldt %w0\\"::\\"r\\" (0)));
	}' unless defined(&clear_LDT);
	eval 'sub LDT_entry_a {
	    local($info) = @_;
    	    eval q((((($info)-> &base_addr & 0xffff) << 16) | (($info)-> &limit & 0xffff)));
	}' unless defined(&LDT_entry_a);
	eval 'sub LDT_entry_b {
	    local($info) = @_;
    	    eval q(((($info)-> &base_addr & 0xff000000) | ((($info)-> &base_addr & 0xff0000) >> 16) | (($info)-> &limit & 0xf0000) | ((($info)-> &read_exec_only ^ 1) << 9) | (($info)-> &contents << 10) | ((($info)-> &seg_not_present ^ 1) << 15) | (($info)-> &seg_32bit << 22) | (($info)-> &limit_in_pages << 23) | (($info)-> &useable << 20) | 0x7000));
	}' unless defined(&LDT_entry_b);
	eval 'sub LDT_empty {
	    local($info) = @_;
    	    eval q(( ($info)-> &base_addr == 0 && ($info)-> &limit == 0 && ($info)-> &contents == 0 && ($info)-> &read_exec_only == 1 && ($info)-> &seg_32bit == 0 && ($info)-> &limit_in_pages == 0 && ($info)-> &seg_not_present == 1 && ($info)-> &useable == 0 && ($info)-> &lm == 0));
	}' unless defined(&LDT_empty);
	if((defined(&TLS_SIZE) ? &TLS_SIZE : 0) != 24) {
	    die("update\ this\ code\.");
	}
    }
}
1;
