require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_64_I387_H)) {
    eval 'sub __ASM_X86_64_I387_H {1;}' unless defined(&__ASM_X86_64_I387_H);
    require 'linux/sched.ph';
    require 'asm/processor.ph';
    require 'asm/sigcontext.ph';
    require 'asm/user.ph';
    require 'asm/thread_info.ph';
    require 'asm/uaccess.ph';
    eval 'sub kernel_fpu_end () {
        eval q( &stts());
    }' unless defined(&kernel_fpu_end);
    eval 'sub unlazy_fpu {
        local($tsk) = @_;
	    eval q( &do {  &if (($tsk)-> ($thread_info->{status}) &  &TS_USEDFPU)  &save_init_fpu($tsk); }  &while (0));
    }' unless defined(&unlazy_fpu);
    eval 'sub clear_fpu {
        local($tsk) = @_;
	    eval q( &do {  &if (($tsk)-> ($thread_info->{status}) &  &TS_USEDFPU) {  &asm  &volatile(\\"fwait\\"); ($tsk)-> ($thread_info->{status}) &= ~ &TS_USEDFPU;  &stts(); } }  &while (0));
    }' unless defined(&clear_fpu);
    eval 'sub load_mxcsr {
        local($val) = @_;
	    eval q( &do { \'unsigned long __mxcsr\' = (($val) & 0xffbf);  &asm  &volatile(\\"ldmxcsr %0\\" : : \\"m\\" ( &__mxcsr)); }  &while (0));
    }' unless defined(&load_mxcsr);
    eval 'sub get_fpu_mxcsr {
        local($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{mxcsr})));
    }' unless defined(&get_fpu_mxcsr);
    eval 'sub get_fpu_cwd {
        local($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{cwd})));
    }' unless defined(&get_fpu_cwd);
    eval 'sub get_fpu_fxsr_twd {
        local($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{twd})));
    }' unless defined(&get_fpu_fxsr_twd);
    eval 'sub get_fpu_swd {
        local($t) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{swd})));
    }' unless defined(&get_fpu_swd);
    eval 'sub set_fpu_cwd {
        local($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{cwd}) = ($val)));
    }' unless defined(&set_fpu_cwd);
    eval 'sub set_fpu_swd {
        local($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{swd}) = ($val)));
    }' unless defined(&set_fpu_swd);
    eval 'sub set_fpu_fxsr_twd {
        local($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{twd}) = ($val)));
    }' unless defined(&set_fpu_fxsr_twd);
    eval 'sub set_fpu_mxcsr {
        local($t,$val) = @_;
	    eval q((($t)-> ($thread->{i387}->{fxsave}->{mxcsr}) = ($val)&0xffbf));
    }' unless defined(&set_fpu_mxcsr);
}
1;
