require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SMP_H)) {
    eval 'sub __ASM_SMP_H {1;}' unless defined(&__ASM_SMP_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/config.ph';
	require 'linux/threads.ph';
	require 'linux/cpumask.ph';
	require 'linux/bitops.ph';
    }
    if(defined(&CONFIG_X86_LOCAL_APIC)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/fixmap.ph';
	    require 'asm/mpspec.ph';
	    if(defined(&CONFIG_X86_IO_APIC)) {
		require 'asm/io_apic.ph';
	    }
	    require 'asm/apic.ph';
	    require 'asm/thread_info.ph';
	}
    }
    if(defined(&CONFIG_SMP)) {
	unless(defined(&ASSEMBLY)) {
	    require 'asm/pda.ph';
	    eval 'sub SMP_TRAMPOLINE_BASE {0x6000;}' unless defined(&SMP_TRAMPOLINE_BASE);
	    eval 'sub cpu_possible_map { &cpu_callout_map;}' unless defined(&cpu_possible_map);
	    eval 'sub cpu_online {
	        local($cpu) = @_;
    		eval q( &cpu_isset($cpu,  &cpu_online_map));
	    }' unless defined(&cpu_online);
	    eval 'sub smp_processor_id () {
	        eval q( &read_pda( &cpunumber));
	    }' unless defined(&smp_processor_id);
	    eval 'sub safe_smp_processor_id () {
	        eval q(( &disable_apic ? 0:  $x86_apicid_to_cpu[ &hard_smp_processor_id()]));
	    }' unless defined(&safe_smp_processor_id);
	    eval 'sub cpu_online {
	        local($cpu) = @_;
    		eval q( &cpu_isset($cpu,  &cpu_online_map));
	    }' unless defined(&cpu_online);
	}
	eval 'sub NO_PROC_ID {0xff;}' unless defined(&NO_PROC_ID);
    }
    eval 'sub INT_DELIVERY_MODE {1;}' unless defined(&INT_DELIVERY_MODE);
    eval 'sub TARGET_CPUS {1;}' unless defined(&TARGET_CPUS);
    unless(defined(&ASSEMBLY)) {
    }
    unless(defined(&CONFIG_SMP)) {
	eval 'sub stack_smp_processor_id () {
	    eval q(0);
	}' unless defined(&stack_smp_processor_id);
	eval 'sub safe_smp_processor_id () {
	    eval q(0);
	}' unless defined(&safe_smp_processor_id);
	eval 'sub cpu_logical_map {
	    local($x) = @_;
    	    eval q(($x));
	}' unless defined(&cpu_logical_map);
    } else {
	require 'asm/thread_info.ph';
	eval 'sub stack_smp_processor_id () {
	    eval q(({ \'struct thread_info\' * &ti;  &__asm__(\\"andq %%rsp,%0; \\":\\"=r\\" ( &ti) : \\"0\\" ( &CURRENT_MASK));  ($ti->{cpu}); }));
	}' unless defined(&stack_smp_processor_id);
    }
}
1;
