require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_BIO_H)) {
    eval 'sub __LINUX_BIO_H {1;}' unless defined(&__LINUX_BIO_H);
    require 'linux/highmem.ph';
    require 'linux/mempool.ph';
    require 'asm/io.ph';
    unless(defined(&BIO_VMERGE_BOUNDARY)) {
	eval 'sub BIO_VMERGE_BOUNDARY {0;}' unless defined(&BIO_VMERGE_BOUNDARY);
    }
    eval 'sub BIO_DEBUG {1;}' unless defined(&BIO_DEBUG);
    if(defined(&BIO_DEBUG)) {
	eval 'sub BIO_BUG_ON { &BUG_ON;}' unless defined(&BIO_BUG_ON);
    } else {
	eval 'sub BIO_BUG_ON {1;}' unless defined(&BIO_BUG_ON);
    }
    eval 'sub BIO_MAX_PAGES {(256);}' unless defined(&BIO_MAX_PAGES);
    eval 'sub BIO_MAX_SIZE {( &BIO_MAX_PAGES <<  &PAGE_CACHE_SHIFT);}' unless defined(&BIO_MAX_SIZE);
    eval 'sub BIO_MAX_SECTORS {( &BIO_MAX_SIZE >> 9);}' unless defined(&BIO_MAX_SECTORS);
    eval 'sub BIO_UPTODATE {0;}' unless defined(&BIO_UPTODATE);
    eval 'sub BIO_RW_BLOCK {1;}' unless defined(&BIO_RW_BLOCK);
    eval 'sub BIO_EOF {2;}' unless defined(&BIO_EOF);
    eval 'sub BIO_SEG_VALID {3;}' unless defined(&BIO_SEG_VALID);
    eval 'sub BIO_CLONED {4;}' unless defined(&BIO_CLONED);
    eval 'sub BIO_BOUNCED {5;}' unless defined(&BIO_BOUNCED);
    eval 'sub bio_flagged {
        local($bio, $flag) = @_;
	    eval q((($bio)-> &bi_flags & (1<< ($flag))));
    }' unless defined(&bio_flagged);
    eval 'sub BIO_POOL_BITS {(4);}' unless defined(&BIO_POOL_BITS);
    eval 'sub BIO_POOL_OFFSET {( &BITS_PER_LONG -  &BIO_POOL_BITS);}' unless defined(&BIO_POOL_OFFSET);
    eval 'sub BIO_POOL_MASK {(1 <<  &BIO_POOL_OFFSET);}' unless defined(&BIO_POOL_MASK);
    eval 'sub BIO_POOL_IDX {
        local($bio) = @_;
	    eval q((($bio)-> &bi_flags >>  &BIO_POOL_OFFSET));
    }' unless defined(&BIO_POOL_IDX);
    eval 'sub BIO_RW {0;}' unless defined(&BIO_RW);
    eval 'sub BIO_RW_AHEAD {1;}' unless defined(&BIO_RW_AHEAD);
    eval 'sub BIO_RW_BARRIER {2;}' unless defined(&BIO_RW_BARRIER);
    eval 'sub BIO_RW_FAILFAST {3;}' unless defined(&BIO_RW_FAILFAST);
    eval 'sub bio_iovec_idx {
        local($bio, $idx) = @_;
	    eval q(((($bio)-> $bi_io_vec[($idx)])));
    }' unless defined(&bio_iovec_idx);
    eval 'sub bio_iovec {
        local($bio) = @_;
	    eval q( &bio_iovec_idx(($bio), ($bio)-> &bi_idx));
    }' unless defined(&bio_iovec);
    eval 'sub bio_page {
        local($bio) = @_;
	    eval q( &bio_iovec(($bio))-> &bv_page);
    }' unless defined(&bio_page);
    eval 'sub bio_offset {
        local($bio) = @_;
	    eval q( &bio_iovec(($bio))-> &bv_offset);
    }' unless defined(&bio_offset);
    eval 'sub bio_segments {
        local($bio) = @_;
	    eval q((($bio)-> &bi_vcnt - ($bio)-> &bi_idx));
    }' unless defined(&bio_segments);
    eval 'sub bio_sectors {
        local($bio) = @_;
	    eval q((($bio)-> &bi_size >> 9));
    }' unless defined(&bio_sectors);
    eval 'sub bio_cur_sectors {
        local($bio) = @_;
	    eval q(( &bio_iovec($bio)-> &bv_len >> 9));
    }' unless defined(&bio_cur_sectors);
    eval 'sub bio_data {
        local($bio) = @_;
	    eval q(( &page_address( &bio_page(($bio))) +  &bio_offset(($bio))));
    }' unless defined(&bio_data);
    eval 'sub bio_barrier {
        local($bio) = @_;
	    eval q((($bio)-> &bi_rw & (1<<  &BIO_RW_BARRIER)));
    }' unless defined(&bio_barrier);
    eval 'sub bio_to_phys {
        local($bio) = @_;
	    eval q(( &page_to_phys( &bio_page()) +  &bio_offset(($bio))));
    }' unless defined(&bio_to_phys);
    eval 'sub bvec_to_phys {
        local($bv) = @_;
	    eval q(( &page_to_phys(-> &bv_page) + ($bv)-> &bv_offset));
    }' unless defined(&bvec_to_phys);
    eval 'sub __bio_kmap_atomic {
        local($bio, $idx, $kmtype) = @_;
	    eval q(( &kmap_atomic( &bio_iovec_idx(($bio), ($idx))-> &bv_page, $kmtype) +  &bio_iovec_idx(($bio), ($idx))-> &bv_offset));
    }' unless defined(&__bio_kmap_atomic);
    eval 'sub __bio_kunmap_atomic {
        local($addr, $kmtype) = @_;
	    eval q( &kunmap_atomic($addr, $kmtype));
    }' unless defined(&__bio_kunmap_atomic);
    eval 'sub __BVEC_END {
        local($bio) = @_;
	    eval q( &bio_iovec_idx(($bio), ($bio)-> &bi_vcnt - 1));
    }' unless defined(&__BVEC_END);
    eval 'sub __BVEC_START {
        local($bio) = @_;
	    eval q( &bio_iovec_idx(($bio), ($bio)-> &bi_idx));
    }' unless defined(&__BVEC_START);
    eval 'sub BIOVEC_PHYS_MERGEABLE {
        local($vec1, $vec2) = @_;
	    eval q((( &bvec_to_phys(($vec1)) + ($vec1)-> &bv_len) ==  &bvec_to_phys(($vec2))));
    }' unless defined(&BIOVEC_PHYS_MERGEABLE);
    eval 'sub BIOVEC_VIRT_MERGEABLE {
        local($vec1, $vec2) = @_;
	    eval q((((( &bvec_to_phys(($vec1)) + ($vec1)-> &bv_len) |  &bvec_to_phys(($vec2))) & ( &BIO_VMERGE_BOUNDARY - 1)) == 0));
    }' unless defined(&BIOVEC_VIRT_MERGEABLE);
    eval 'sub __BIO_SEG_BOUNDARY {
        local($addr1, $addr2, $mask) = @_;
	    eval q(((($addr1) | ($mask)) == ((($addr2) - 1) | ($mask))));
    }' unless defined(&__BIO_SEG_BOUNDARY);
    eval 'sub BIOVEC_SEG_BOUNDARY {
        local($q, $b1, $b2) = @_;
	    eval q( &__BIO_SEG_BOUNDARY( &bvec_to_phys(($b1)),  &bvec_to_phys(($b2)) + ($b2)-> &bv_len, ($q)-> &seg_boundary_mask));
    }' unless defined(&BIOVEC_SEG_BOUNDARY);
    eval 'sub BIO_SEG_BOUNDARY {
        local($q, $b1, $b2) = @_;
	    eval q( &BIOVEC_SEG_BOUNDARY(($q),  &__BVEC_END(($b1)),  &__BVEC_START(($b2))));
    }' unless defined(&BIO_SEG_BOUNDARY);
    eval 'sub bio_io_error {
        local($bio, $bytes) = @_;
	    eval q( &bio_endio(($bio), ($bytes), - &EIO));
    }' unless defined(&bio_io_error);
    eval 'sub __bio_for_each_segment {
        local($bvl, $bio, $i, $start_idx) = @_;
	    eval q( &for ($bvl =  &bio_iovec_idx(($bio), ($start_idx)), $i = ($start_idx); $i < ($bio)-> &bi_vcnt; $bvl++, $i++));
    }' unless defined(&__bio_for_each_segment);
    eval 'sub bio_for_each_segment {
        local($bvl, $bio, $i) = @_;
	    eval q( &__bio_for_each_segment($bvl, $bio, $i, ($bio)-> &bi_idx));
    }' unless defined(&bio_for_each_segment);
    eval 'sub bio_get {
        local($bio) = @_;
	    eval q( &atomic_inc(($bio)-> &bi_cnt));
    }' unless defined(&bio_get);
    if(defined(&CONFIG_HIGHMEM)) {
    } else {
	eval 'sub bvec_kmap_irq {
	    local($bvec, $flags) = @_;
    	    eval q(( &page_address(($bvec)-> &bv_page) + ($bvec)-> &bv_offset));
	}' unless defined(&bvec_kmap_irq);
	eval 'sub bvec_kunmap_irq {
	    local($buf, $flags) = @_;
    	    eval q( &do { *($flags) = 0; }  &while (0));
	}' unless defined(&bvec_kunmap_irq);
    }
    eval 'sub __bio_kunmap_irq {
        local($buf, $flags) = @_;
	    eval q( &bvec_kunmap_irq($buf, $flags));
    }' unless defined(&__bio_kunmap_irq);
    eval 'sub bio_kmap_irq {
        local($bio, $flags) = @_;
	    eval q( &__bio_kmap_irq(($bio), ($bio)-> &bi_idx, ($flags)));
    }' unless defined(&bio_kmap_irq);
    eval 'sub bio_kunmap_irq {
        local($buf,$flags) = @_;
	    eval q( &__bio_kunmap_irq($buf, $flags));
    }' unless defined(&bio_kunmap_irq);
}
1;
