require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_COMPILER_H)) {
    eval 'sub __LINUX_COMPILER_H {1;}' unless defined(&__LINUX_COMPILER_H);
    unless(defined(&__KERNEL__)) {
	eval 'sub __user {1;}' unless defined(&__user);
	eval 'sub __kernel {1;}' unless defined(&__kernel);
	eval 'sub __attribute_const__ {1;}' unless defined(&__attribute_const__);
	if(((defined(&__GNUC__) ? &__GNUC__ : 0) > 3) || ((defined(&__GNUC__) ? &__GNUC__ : 0) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 1)) {
	    eval 'sub inline { &__inline__;}' unless defined(&inline);
	    eval 'sub __inline__ { &__inline__;}' unless defined(&__inline__);
	    eval 'sub __inline { &__inline__;}' unless defined(&__inline);
	}
    } else {
	if(defined(&__CHECKER__)) {
	    eval 'sub __user { &__attribute__(( &noderef,  &address_space(1)));}' unless defined(&__user);
	    eval 'sub __kernel {1;}' unless defined(&__kernel);
	} else {
	    eval 'sub __user {1;}' unless defined(&__user);
	    eval 'sub __kernel {1;}' unless defined(&__kernel);
	}
	if(defined(&__KERNEL__)) {
	    unless(defined(&__ASSEMBLY__)) {
		if((defined(&__GNUC__) ? &__GNUC__ : 0) > 3) {
		    require 'linux/compiler-gcc+.ph';
		}
 elsif((defined(&__GNUC__) ? &__GNUC__ : 0) == 3) {
		    require 'linux/compiler-gcc3.ph';
		}
 elsif((defined(&__GNUC__) ? &__GNUC__ : 0) == 2) {
		    require 'linux/compiler-gcc2.ph';
		} else {
		    die("Sorry\,\ your\ compiler\ is\ too\ old\/not\ recognized\.");
		}
	    }
	    if(defined(&__INTEL_COMPILER)) {
		require 'linux/compiler-intel.ph';
	    }
	}
	eval 'sub likely {
	    local($x) = @_;
    	    eval q( &__builtin_expect(!!($x), 1));
	}' unless defined(&likely);
	eval 'sub unlikely {
	    local($x) = @_;
    	    eval q( &__builtin_expect(!!($x), 0));
	}' unless defined(&unlikely);
	unless(defined(&barrier)) {
	    eval 'sub barrier () {
	        eval q( &__memory_barrier());
	    }' unless defined(&barrier);
	}
	unless(defined(&RELOC_HIDE)) {
	    eval 'sub RELOC_HIDE {
	        local($ptr, $off) = @_;
    		eval q(({ \'unsigned long __ptr\';  &__ptr = ($ptr); ( &typeof($ptr)) ( &__ptr + ($off)); }));
	    }' unless defined(&RELOC_HIDE);
	}
	unless(defined(&__deprecated)) {
	    eval 'sub __deprecated {1;}' unless defined(&__deprecated);
	}
	unless(defined(&__attribute_used__)) {
	    eval 'sub __attribute_used__ {1;}' unless defined(&__attribute_used__);
	}
	unless(defined(&__attribute_pure__)) {
	    eval 'sub __attribute_pure__ {1;}' unless defined(&__attribute_pure__);
	}
	unless(defined(&__attribute_const__)) {
	    eval 'sub __attribute_const__ {1;}' unless defined(&__attribute_const__);
	}
	unless(defined(&noinline)) {
	    eval 'sub noinline {1;}' unless defined(&noinline);
	}
    }
}
1;
