require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_CPUMASK_H)) {
    eval 'sub __LINUX_CPUMASK_H {1;}' unless defined(&__LINUX_CPUMASK_H);
    require 'linux/threads.ph';
    require 'linux/bitmap.ph';
    require 'asm/cpumask.ph';
    require 'asm/bug.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub num_online_cpus () {
	    eval q( &cpus_weight( &cpu_online_map));
	}' unless defined(&num_online_cpus);
	eval 'sub num_possible_cpus () {
	    eval q( &cpus_weight( &cpu_possible_map));
	}' unless defined(&num_possible_cpus);
	eval 'sub cpu_online {
	    local($cpu) = @_;
    	    eval q( &cpu_isset($cpu,  &cpu_online_map));
	}' unless defined(&cpu_online);
	eval 'sub cpu_possible {
	    local($cpu) = @_;
    	    eval q( &cpu_isset($cpu,  &cpu_possible_map));
	}' unless defined(&cpu_possible);
	eval 'sub for_each_cpu_mask {
	    local($cpu, $mask) = @_;
    	    eval q( &for ($cpu =  &first_cpu_const( &mk_cpumask_const($mask)); $cpu <  &NR_CPUS; $cpu =  &next_cpu_const($cpu,  &mk_cpumask_const($mask))));
	}' unless defined(&for_each_cpu_mask);
	eval 'sub for_each_cpu {
	    local($cpu) = @_;
    	    eval q( &for_each_cpu_mask($cpu,  &cpu_possible_map));
	}' unless defined(&for_each_cpu);
	eval 'sub for_each_online_cpu {
	    local($cpu) = @_;
    	    eval q( &for_each_cpu_mask($cpu,  &cpu_online_map));
	}' unless defined(&for_each_online_cpu);
    } else {
	eval 'sub cpu_online_map { &cpumask_of_cpu(0);}' unless defined(&cpu_online_map);
	eval 'sub cpu_possible_map { &cpumask_of_cpu(0);}' unless defined(&cpu_possible_map);
	eval 'sub num_online_cpus () {
	    eval q(1);
	}' unless defined(&num_online_cpus);
	eval 'sub num_possible_cpus () {
	    eval q(1);
	}' unless defined(&num_possible_cpus);
	eval 'sub cpu_online {
	    local($cpu) = @_;
    	    eval q(({  &BUG_ON(($cpu) != 0); 1; }));
	}' unless defined(&cpu_online);
	eval 'sub cpu_possible {
	    local($cpu) = @_;
    	    eval q(({  &BUG_ON(($cpu) != 0); 1; }));
	}' unless defined(&cpu_possible);
	eval 'sub for_each_cpu {
	    local($cpu) = @_;
    	    eval q( &for ($cpu = 0; $cpu < 1; $cpu++));
	}' unless defined(&for_each_cpu);
	eval 'sub for_each_online_cpu {
	    local($cpu) = @_;
    	    eval q( &for ($cpu = 0; $cpu < 1; $cpu++));
	}' unless defined(&for_each_online_cpu);
    }
    eval 'sub cpumask_scnprintf {
        local($buf, $buflen, $map) = @_;
	    eval q( &bitmap_scnprintf($buf, $buflen,  &cpus_addr($map),  &NR_CPUS));
    }' unless defined(&cpumask_scnprintf);
    eval 'sub cpumask_parse {
        local($buf, $buflen, $map) = @_;
	    eval q( &bitmap_parse($buf, $buflen,  &cpus_addr($map),  &NR_CPUS));
    }' unless defined(&cpumask_parse);
}
1;
