require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HIGHUID_H)) {
    eval 'sub _LINUX_HIGHUID_H {1;}' unless defined(&_LINUX_HIGHUID_H);
    require 'linux/config.ph';
    require 'linux/types.ph';
    eval 'sub DEFAULT_OVERFLOWUID {65534;}' unless defined(&DEFAULT_OVERFLOWUID);
    eval 'sub DEFAULT_OVERFLOWGID {65534;}' unless defined(&DEFAULT_OVERFLOWGID);
    if(defined(&CONFIG_UID16)) {
	eval 'sub high2lowuid {
	    local($uid) = @_;
    	    eval q(( > 65535?  &overflowuid : ($uid)));
	}' unless defined(&high2lowuid);
	eval 'sub high2lowgid {
	    local($gid) = @_;
    	    eval q(( > 65535?  &overflowgid : ($gid)));
	}' unless defined(&high2lowgid);
	eval 'sub low2highuid {
	    local($uid) = @_;
    	    eval q(( == -1? -1: ($uid)));
	}' unless defined(&low2highuid);
	eval 'sub low2highgid {
	    local($gid) = @_;
    	    eval q(( == -1? -1: ($gid)));
	}' unless defined(&low2highgid);
	eval 'sub __convert_uid {
	    local($size, $uid) = @_;
    	    eval q(($size >= $sizeof{$uid} ? ($uid) :  &high2lowuid($uid)));
	}' unless defined(&__convert_uid);
	eval 'sub __convert_gid {
	    local($size, $gid) = @_;
    	    eval q(($size >= $sizeof{$gid} ? ($gid) :  &high2lowgid($gid)));
	}' unless defined(&__convert_gid);
    } else {
	eval 'sub __convert_uid {
	    local($size, $uid) = @_;
    	    eval q(($uid));
	}' unless defined(&__convert_uid);
	eval 'sub __convert_gid {
	    local($size, $gid) = @_;
    	    eval q(($gid));
	}' unless defined(&__convert_gid);
    }
    eval 'sub SET_UID {
        local($var, $uid) = @_;
	    eval q( &do { ($var) =  &__convert_uid($sizeof{$var}, ($uid)); }  &while (0));
    }' unless defined(&SET_UID);
    eval 'sub SET_GID {
        local($var, $gid) = @_;
	    eval q( &do { ($var) =  &__convert_gid($sizeof{$var}, ($gid)); }  &while (0));
    }' unless defined(&SET_GID);
    eval 'sub DEFAULT_FS_OVERFLOWUID {65534;}' unless defined(&DEFAULT_FS_OVERFLOWUID);
    eval 'sub DEFAULT_FS_OVERFLOWGID {65534;}' unless defined(&DEFAULT_FS_OVERFLOWGID);
    eval 'sub fs_high2lowuid {
        local($uid) = @_;
	    eval q(( > 65535?  &fs_overflowuid : ($uid)));
    }' unless defined(&fs_high2lowuid);
    eval 'sub fs_high2lowgid {
        local($gid) = @_;
	    eval q(( > 65535?  &fs_overflowgid : ($gid)));
    }' unless defined(&fs_high2lowgid);
    eval 'sub low_16_bits {
        local($x) = @_;
	    eval q((($x) & 0xffff));
    }' unless defined(&low_16_bits);
    eval 'sub high_16_bits {
        local($x) = @_;
	    eval q(((($x) & 0xffff0000) >> 16));
    }' unless defined(&high_16_bits);
}
1;
