require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_JFFS2_H__)) {
    eval 'sub __LINUX_JFFS2_H__ {1;}' unless defined(&__LINUX_JFFS2_H__);
    eval 'sub JFFS2_SUPER_MAGIC {0x72b6;}' unless defined(&JFFS2_SUPER_MAGIC);
    eval 'sub JFFS2_OLD_MAGIC_BITMASK {0x1984;}' unless defined(&JFFS2_OLD_MAGIC_BITMASK);
    eval 'sub JFFS2_MAGIC_BITMASK {0x1985;}' unless defined(&JFFS2_MAGIC_BITMASK);
    eval 'sub KSAMTIB_CIGAM_2SFFJ {0x8519;}' unless defined(&KSAMTIB_CIGAM_2SFFJ);
    eval 'sub JFFS2_EMPTY_BITMASK {0xffff;}' unless defined(&JFFS2_EMPTY_BITMASK);
    eval 'sub JFFS2_DIRTY_BITMASK {0x;}' unless defined(&JFFS2_DIRTY_BITMASK);
    eval 'sub JFFS2_MAX_NAME_LEN {254;}' unless defined(&JFFS2_MAX_NAME_LEN);
    eval 'sub JFFS2_MIN_DATA_LEN {128;}' unless defined(&JFFS2_MIN_DATA_LEN);
    eval 'sub JFFS2_COMPR_NONE {0x;}' unless defined(&JFFS2_COMPR_NONE);
    eval 'sub JFFS2_COMPR_ZERO {0x1;}' unless defined(&JFFS2_COMPR_ZERO);
    eval 'sub JFFS2_COMPR_RTIME {0x2;}' unless defined(&JFFS2_COMPR_RTIME);
    eval 'sub JFFS2_COMPR_RUBINMIPS {0x3;}' unless defined(&JFFS2_COMPR_RUBINMIPS);
    eval 'sub JFFS2_COMPR_COPY {0x4;}' unless defined(&JFFS2_COMPR_COPY);
    eval 'sub JFFS2_COMPR_DYNRUBIN {0x5;}' unless defined(&JFFS2_COMPR_DYNRUBIN);
    eval 'sub JFFS2_COMPR_ZLIB {0x6;}' unless defined(&JFFS2_COMPR_ZLIB);
    eval 'sub JFFS2_COMPAT_MASK {0xc000;}' unless defined(&JFFS2_COMPAT_MASK);
    eval 'sub JFFS2_NODE_ACCURATE {0x2000;}' unless defined(&JFFS2_NODE_ACCURATE);
    eval 'sub JFFS2_FEATURE_INCOMPAT {0xc000;}' unless defined(&JFFS2_FEATURE_INCOMPAT);
    eval 'sub JFFS2_FEATURE_ROCOMPAT {0x8000;}' unless defined(&JFFS2_FEATURE_ROCOMPAT);
    eval 'sub JFFS2_FEATURE_RWCOMPAT_COPY {0x4000;}' unless defined(&JFFS2_FEATURE_RWCOMPAT_COPY);
    eval 'sub JFFS2_FEATURE_RWCOMPAT_DELETE {0x;}' unless defined(&JFFS2_FEATURE_RWCOMPAT_DELETE);
    eval 'sub JFFS2_NODETYPE_DIRENT {( &JFFS2_FEATURE_INCOMPAT |  &JFFS2_NODE_ACCURATE | 1);}' unless defined(&JFFS2_NODETYPE_DIRENT);
    eval 'sub JFFS2_NODETYPE_INODE {( &JFFS2_FEATURE_INCOMPAT |  &JFFS2_NODE_ACCURATE | 2);}' unless defined(&JFFS2_NODETYPE_INODE);
    eval 'sub JFFS2_NODETYPE_CLEANMARKER {( &JFFS2_FEATURE_RWCOMPAT_DELETE |  &JFFS2_NODE_ACCURATE | 3);}' unless defined(&JFFS2_NODETYPE_CLEANMARKER);
    eval 'sub JFFS2_NODETYPE_PADDING {( &JFFS2_FEATURE_RWCOMPAT_DELETE |  &JFFS2_NODE_ACCURATE | 4);}' unless defined(&JFFS2_NODETYPE_PADDING);
    eval 'sub JFFS2_INO_FLAG_PREREAD {1;}' unless defined(&JFFS2_INO_FLAG_PREREAD);
    eval 'sub JFFS2_INO_FLAG_USERCOMPR {2;}' unless defined(&JFFS2_INO_FLAG_USERCOMPR);
    eval 'sub JFFS2_NATIVE_ENDIAN {1;}' unless defined(&JFFS2_NATIVE_ENDIAN);
    if(defined( &JFFS2_NATIVE_ENDIAN)) {
	eval 'sub cpu_to_je16 {
	    local($x) = @_;
    	    eval q((( &jint16_t){$x}));
	}' unless defined(&cpu_to_je16);
	eval 'sub cpu_to_je32 {
	    local($x) = @_;
    	    eval q((( &jint32_t){$x}));
	}' unless defined(&cpu_to_je32);
	eval 'sub cpu_to_jemode {
	    local($x) = @_;
    	    eval q((( &jmode_t){ &os_to_jffs2_mode($x)}));
	}' unless defined(&cpu_to_jemode);
	eval 'sub je16_to_cpu {
	    local($x) = @_;
    	    eval q((($x). &v16));
	}' unless defined(&je16_to_cpu);
	eval 'sub je32_to_cpu {
	    local($x) = @_;
    	    eval q((($x). &v32));
	}' unless defined(&je32_to_cpu);
	eval 'sub jemode_to_cpu {
	    local($x) = @_;
    	    eval q(( &jffs2_to_os_mode(($x). &m)));
	}' unless defined(&jemode_to_cpu);
    }
 elsif(defined( &JFFS2_BIG_ENDIAN)) {
	eval 'sub cpu_to_je16 {
	    local($x) = @_;
    	    eval q((( &jint16_t){ &cpu_to_be16($x)}));
	}' unless defined(&cpu_to_je16);
	eval 'sub cpu_to_je32 {
	    local($x) = @_;
    	    eval q((( &jint32_t){ &cpu_to_be32($x)}));
	}' unless defined(&cpu_to_je32);
	eval 'sub cpu_to_jemode {
	    local($x) = @_;
    	    eval q((( &jmode_t){ &cpu_to_be32( &os_to_jffs2_mode($x))}));
	}' unless defined(&cpu_to_jemode);
	eval 'sub je16_to_cpu {
	    local($x) = @_;
    	    eval q(( &be16_to_cpu( ($x->{v16}))));
	}' unless defined(&je16_to_cpu);
	eval 'sub je32_to_cpu {
	    local($x) = @_;
    	    eval q(( &be32_to_cpu( ($x->{v32}))));
	}' unless defined(&je32_to_cpu);
	eval 'sub jemode_to_cpu {
	    local($x) = @_;
    	    eval q(( &be32_to_cpu( &jffs2_to_os_mode(($x). &m))));
	}' unless defined(&jemode_to_cpu);
    }
 elsif(defined( &JFFS2_LITTLE_ENDIAN)) {
	eval 'sub cpu_to_je16 {
	    local($x) = @_;
    	    eval q((( &jint16_t){ &cpu_to_le16($x)}));
	}' unless defined(&cpu_to_je16);
	eval 'sub cpu_to_je32 {
	    local($x) = @_;
    	    eval q((( &jint32_t){ &cpu_to_le32($x)}));
	}' unless defined(&cpu_to_je32);
	eval 'sub cpu_to_jemode {
	    local($x) = @_;
    	    eval q((( &jmode_t){ &cpu_to_le32( &os_to_jffs2_mode($x))}));
	}' unless defined(&cpu_to_jemode);
	eval 'sub je16_to_cpu {
	    local($x) = @_;
    	    eval q(( &le16_to_cpu( ($x->{v16}))));
	}' unless defined(&je16_to_cpu);
	eval 'sub je32_to_cpu {
	    local($x) = @_;
    	    eval q(( &le32_to_cpu( ($x->{v32}))));
	}' unless defined(&je32_to_cpu);
	eval 'sub jemode_to_cpu {
	    local($x) = @_;
    	    eval q(( &le32_to_cpu( &jffs2_to_os_mode(($x). &m))));
	}' unless defined(&jemode_to_cpu);
    } else {
	die("wibble");
    }
}
1;
