require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_LIBATA_H__)) {
    eval 'sub __LINUX_LIBATA_H__ {1;}' unless defined(&__LINUX_LIBATA_H__);
    require 'linux/delay.ph';
    require 'linux/interrupt.ph';
    require 'asm/io.ph';
    require 'linux/ata.ph';
    undef(&ATA_FORCE_PIO) if defined(&ATA_FORCE_PIO);
    undef(&ATA_DEBUG) if defined(&ATA_DEBUG);
    undef(&ATA_VERBOSE_DEBUG) if defined(&ATA_VERBOSE_DEBUG);
    undef(&ATA_IRQ_TRAP) if defined(&ATA_IRQ_TRAP);
    undef(&ATA_NDEBUG) if defined(&ATA_NDEBUG);
    undef(&ATA_ENABLE_ATAPI) if defined(&ATA_ENABLE_ATAPI);
    undef(&ATA_ENABLE_PATA) if defined(&ATA_ENABLE_PATA);
    if(defined(&ATA_DEBUG)) {
	eval 'sub DPRINTK {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&DPRINTK);
	if(defined(&ATA_VERBOSE_DEBUG)) {
	    eval 'sub VPRINTK {( &fmt,  &args...)  &printk( &KERN_ERR "%s: "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&VPRINTK);
	} else {
	    eval 'sub VPRINTK {( &fmt,  &args...);}' unless defined(&VPRINTK);
	}
    } else {
	eval 'sub DPRINTK {( &fmt,  &args...);}' unless defined(&DPRINTK);
	eval 'sub VPRINTK {( &fmt,  &args...);}' unless defined(&VPRINTK);
    }
    if(defined(&ATA_NDEBUG)) {
	eval 'sub assert {
	    local($expr) = @_;
    	    eval q();
	}' unless defined(&assert);
    } else {
	eval 'sub assert {
	    local($expr) = @_;
    	    eval q( &if( &unlikely(!($expr))) {  &printk( &KERN_ERR \\"Assertion failed! %s,%s,%s,line=%d\\\\n\\", $expr, &__FILE__, &__FUNCTION__, &__LINE__); });
	}' unless defined(&assert);
    }
    eval 'sub ATA_TAG_POISON {0xfafbfcfd;}' unless defined(&ATA_TAG_POISON);
    eval("sub LIBATA_MAX_PRD () { ATA_MAX_PRD/2; }") unless defined(&LIBATA_MAX_PRD);
    eval("sub ATA_MAX_PORTS () { 8; }") unless defined(&ATA_MAX_PORTS);
    eval("sub ATA_DEF_QUEUE () { 1; }") unless defined(&ATA_DEF_QUEUE);
    eval("sub ATA_MAX_QUEUE () { 1; }") unless defined(&ATA_MAX_QUEUE);
    eval("sub ATA_MAX_SECTORS () { 200; }") unless defined(&ATA_MAX_SECTORS);
    eval("sub ATA_MAX_BUS () { 2; }") unless defined(&ATA_MAX_BUS);
    eval("sub ATA_DEF_BUSY_WAIT () { 10000; }") unless defined(&ATA_DEF_BUSY_WAIT);
    eval("sub ATA_SHORT_PAUSE () { (HZ>>6)+1; }") unless defined(&ATA_SHORT_PAUSE);
    eval("sub ATA_SHT_EMULATED () { 1; }") unless defined(&ATA_SHT_EMULATED);
    eval("sub ATA_SHT_CMD_PER_LUN () { 1; }") unless defined(&ATA_SHT_CMD_PER_LUN);
    eval("sub ATA_SHT_THIS_ID () { -1; }") unless defined(&ATA_SHT_THIS_ID);
    eval("sub ATA_SHT_USE_CLUSTERING () { 0; }") unless defined(&ATA_SHT_USE_CLUSTERING);
    eval("sub ATA_DFLAG_LBA48 () { (1<<0); }") unless defined(&ATA_DFLAG_LBA48);
    eval("sub ATA_DFLAG_PIO () { (1<<1); }") unless defined(&ATA_DFLAG_PIO);
    eval("sub ATA_DFLAG_MASTER () { (1<<2); }") unless defined(&ATA_DFLAG_MASTER);
    eval("sub ATA_DFLAG_WCACHE () { (1<<3); }") unless defined(&ATA_DFLAG_WCACHE);
    eval("sub ATA_DEV_UNKNOWN () { 0; }") unless defined(&ATA_DEV_UNKNOWN);
    eval("sub ATA_DEV_ATA () { 1; }") unless defined(&ATA_DEV_ATA);
    eval("sub ATA_DEV_ATA_UNSUP () { 2; }") unless defined(&ATA_DEV_ATA_UNSUP);
    eval("sub ATA_DEV_ATAPI () { 3; }") unless defined(&ATA_DEV_ATAPI);
    eval("sub ATA_DEV_ATAPI_UNSUP () { 4; }") unless defined(&ATA_DEV_ATAPI_UNSUP);
    eval("sub ATA_DEV_NONE () { 5; }") unless defined(&ATA_DEV_NONE);
    eval("sub ATA_FLAG_SLAVE_POSS () { (1<<1); }") unless defined(&ATA_FLAG_SLAVE_POSS);
    eval("sub ATA_FLAG_PORT_DISABLED () { (1<<2); }") unless defined(&ATA_FLAG_PORT_DISABLED);
    eval("sub ATA_FLAG_SATA () { (1<<3); }") unless defined(&ATA_FLAG_SATA);
    eval("sub ATA_FLAG_NO_LEGACY () { (1<<4); }") unless defined(&ATA_FLAG_NO_LEGACY);
    eval("sub ATA_FLAG_SRST () { (1<<5); }") unless defined(&ATA_FLAG_SRST);
    eval("sub ATA_FLAG_MMIO () { (1<<6); }") unless defined(&ATA_FLAG_MMIO);
    eval("sub ATA_FLAG_SATA_RESET () { (1<<7); }") unless defined(&ATA_FLAG_SATA_RESET);
    eval("sub ATA_TFLAG_LBA48 () { (1<<0); }") unless defined(&ATA_TFLAG_LBA48);
    eval("sub ATA_TFLAG_ISADDR () { (1<<1); }") unless defined(&ATA_TFLAG_ISADDR);
    eval("sub ATA_TFLAG_DEVICE () { (1<<2); }") unless defined(&ATA_TFLAG_DEVICE);
    eval("sub ATA_QCFLAG_WRITE () { (1<<0); }") unless defined(&ATA_QCFLAG_WRITE);
    eval("sub ATA_QCFLAG_ACTIVE () { (1<<1); }") unless defined(&ATA_QCFLAG_ACTIVE);
    eval("sub ATA_QCFLAG_DMA () { (1<<2); }") unless defined(&ATA_QCFLAG_DMA);
    eval("sub ATA_QCFLAG_ATAPI () { (1<<3); }") unless defined(&ATA_QCFLAG_ATAPI);
    eval("sub ATA_QCFLAG_SG () { (1<<4); }") unless defined(&ATA_QCFLAG_SG);
    eval("sub ATA_QCFLAG_POLL () { (1<<5); }") unless defined(&ATA_QCFLAG_POLL);
    eval("sub ATA_EFLG_ACTIVE () { 0; }") unless defined(&ATA_EFLG_ACTIVE);
    eval("sub ATA_TMOUT_EDD () { 5*HZ; }") unless defined(&ATA_TMOUT_EDD);
    eval("sub ATA_TMOUT_PIO () { 30*HZ; }") unless defined(&ATA_TMOUT_PIO);
    eval("sub ATA_TMOUT_BOOT () { 30*HZ; }") unless defined(&ATA_TMOUT_BOOT);
    eval("sub ATA_TMOUT_BOOT_QUICK () { 7*HZ; }") unless defined(&ATA_TMOUT_BOOT_QUICK);
    eval("sub ATA_TMOUT_CDB () { 30*HZ; }") unless defined(&ATA_TMOUT_CDB);
    eval("sub ATA_TMOUT_CDB_QUICK () { 5*HZ; }") unless defined(&ATA_TMOUT_CDB_QUICK);
    eval("sub BUS_UNKNOWN () { 0; }") unless defined(&BUS_UNKNOWN);
    eval("sub BUS_DMA () { 1; }") unless defined(&BUS_DMA);
    eval("sub BUS_IDLE () { 2; }") unless defined(&BUS_IDLE);
    eval("sub BUS_NOINTR () { 3; }") unless defined(&BUS_NOINTR);
    eval("sub BUS_NODATA () { 4; }") unless defined(&BUS_NODATA);
    eval("sub BUS_TIMER () { 5; }") unless defined(&BUS_TIMER);
    eval("sub BUS_PIO () { 6; }") unless defined(&BUS_PIO);
    eval("sub BUS_EDD () { 7; }") unless defined(&BUS_EDD);
    eval("sub BUS_IDENTIFY () { 8; }") unless defined(&BUS_IDENTIFY);
    eval("sub BUS_PACKET () { 9; }") unless defined(&BUS_PACKET);
    eval("sub THR_UNKNOWN () { 0; }") unless defined(&THR_UNKNOWN);
    eval("sub THR_PORT_RESET () { (THR_UNKNOWN+1); }") unless defined(&THR_PORT_RESET);
    eval("sub THR_AWAIT_DEATH () { (THR_PORT_RESET+1); }") unless defined(&THR_AWAIT_DEATH);
    eval("sub THR_PROBE_FAILED () { (THR_AWAIT_DEATH+1); }") unless defined(&THR_PROBE_FAILED);
    eval("sub THR_IDLE () { (THR_PROBE_FAILED+1); }") unless defined(&THR_IDLE);
    eval("sub THR_PROBE_SUCCESS () { (THR_IDLE+1); }") unless defined(&THR_PROBE_SUCCESS);
    eval("sub THR_PROBE_START () { (THR_PROBE_SUCCESS+1); }") unless defined(&THR_PROBE_START);
    eval("sub THR_PIO_POLL () { (THR_PROBE_START+1); }") unless defined(&THR_PIO_POLL);
    eval("sub THR_PIO_TMOUT () { (THR_PIO_POLL+1); }") unless defined(&THR_PIO_TMOUT);
    eval("sub THR_PIO () { (THR_PIO_TMOUT+1); }") unless defined(&THR_PIO);
    eval("sub THR_PIO_LAST () { (THR_PIO+1); }") unless defined(&THR_PIO_LAST);
    eval("sub THR_PIO_LAST_POLL () { (THR_PIO_LAST+1); }") unless defined(&THR_PIO_LAST_POLL);
    eval("sub THR_PIO_ERR () { (THR_PIO_LAST_POLL+1); }") unless defined(&THR_PIO_ERR);
    eval("sub THR_PACKET () { (THR_PIO_ERR+1); }") unless defined(&THR_PACKET);
    eval("sub PORT_UNKNOWN () { 0; }") unless defined(&PORT_UNKNOWN);
    eval("sub PORT_ENABLED () { 1; }") unless defined(&PORT_ENABLED);
    eval("sub PORT_DISABLED () { 2; }") unless defined(&PORT_DISABLED);
    eval("sub ATA_QCFLAG_TIMEOUT () { (1<<0); }") unless defined(&ATA_QCFLAG_TIMEOUT);
}
1;
