require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MM_H)) {
    eval 'sub _LINUX_MM_H {1;}' unless defined(&_LINUX_MM_H);
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/gfp.ph';
	require 'linux/list.ph';
	require 'linux/mmzone.ph';
	require 'linux/rbtree.ph';
	require 'linux/fs.ph';
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	}
	require 'asm/page.ph';
	require 'asm/pgtable.ph';
	require 'asm/processor.ph';
	require 'asm/atomic.ph';
	unless(defined(&MM_VM_SIZE)) {
	    eval 'sub MM_VM_SIZE {
	        local($mm) = @_;
    		eval q( &TASK_SIZE);
	    }' unless defined(&MM_VM_SIZE);
	}
	eval 'sub VM_READ {0x1;}' unless defined(&VM_READ);
	eval 'sub VM_WRITE {0x2;}' unless defined(&VM_WRITE);
	eval 'sub VM_EXEC {0x4;}' unless defined(&VM_EXEC);
	eval 'sub VM_SHARED {0x8;}' unless defined(&VM_SHARED);
	eval 'sub VM_MAYREAD {0x10;}' unless defined(&VM_MAYREAD);
	eval 'sub VM_MAYWRITE {0x20;}' unless defined(&VM_MAYWRITE);
	eval 'sub VM_MAYEXEC {0x40;}' unless defined(&VM_MAYEXEC);
	eval 'sub VM_MAYSHARE {0x80;}' unless defined(&VM_MAYSHARE);
	eval 'sub VM_GROWSDOWN {0x100;}' unless defined(&VM_GROWSDOWN);
	eval 'sub VM_GROWSUP {0x200;}' unless defined(&VM_GROWSUP);
	eval 'sub VM_SHM {0x400;}' unless defined(&VM_SHM);
	eval 'sub VM_DENYWRITE {0x800;}' unless defined(&VM_DENYWRITE);
	eval 'sub VM_EXECUTABLE {0x1000;}' unless defined(&VM_EXECUTABLE);
	eval 'sub VM_LOCKED {0x2000;}' unless defined(&VM_LOCKED);
	eval 'sub VM_IO {0x4000;}' unless defined(&VM_IO);
	eval 'sub VM_SEQ_READ {0x8000;}' unless defined(&VM_SEQ_READ);
	eval 'sub VM_RAND_READ {0x10000;}' unless defined(&VM_RAND_READ);
	eval 'sub VM_DONTCOPY {0x20000;}' unless defined(&VM_DONTCOPY);
	eval 'sub VM_DONTEXPAND {0x40000;}' unless defined(&VM_DONTEXPAND);
	eval 'sub VM_RESERVED {0x80000;}' unless defined(&VM_RESERVED);
	eval 'sub VM_ACCOUNT {0x100000;}' unless defined(&VM_ACCOUNT);
	eval 'sub VM_HUGETLB {0x400000;}' unless defined(&VM_HUGETLB);
	eval 'sub VM_NONLINEAR {0x800000;}' unless defined(&VM_NONLINEAR);
	eval 'sub VM_MAYACCT {
	    local($vma) = @_;
    	    eval q((!!(($vma)-> &vm_flags &  &VM_HUGETLB)));
	}' unless defined(&VM_MAYACCT);
	unless(defined(&VM_STACK_DEFAULT_FLAGS)) {
	    eval 'sub VM_STACK_DEFAULT_FLAGS { &VM_DATA_DEFAULT_FLAGS;}' unless defined(&VM_STACK_DEFAULT_FLAGS);
	}
	if(defined(&CONFIG_STACK_GROWSUP)) {
	    eval 'sub VM_STACK_FLAGS {( &VM_GROWSUP |  &VM_STACK_DEFAULT_FLAGS |  &VM_ACCOUNT);}' unless defined(&VM_STACK_FLAGS);
	} else {
	    eval 'sub VM_STACK_FLAGS {( &VM_GROWSDOWN |  &VM_STACK_DEFAULT_FLAGS |  &VM_ACCOUNT);}' unless defined(&VM_STACK_FLAGS);
	}
	eval 'sub VM_READHINTMASK {( &VM_SEQ_READ |  &VM_RAND_READ);}' unless defined(&VM_READHINTMASK);
	eval 'sub VM_ClearReadHint {
	    local($v) = @_;
    	    eval q(($v)-> &vm_flags &= ~ &VM_READHINTMASK);
	}' unless defined(&VM_ClearReadHint);
	eval 'sub VM_NormalReadHint {
	    local($v) = @_;
    	    eval q((!(($v)-> &vm_flags &  &VM_READHINTMASK)));
	}' unless defined(&VM_NormalReadHint);
	eval 'sub VM_SequentialReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_SEQ_READ));
	}' unless defined(&VM_SequentialReadHint);
	eval 'sub VM_RandomReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_RAND_READ));
	}' unless defined(&VM_RandomReadHint);
	if(defined(&ARCH_HAS_ATOMIC_UNSIGNED)) {
	} else {
	}
	if(defined( &WANT_PAGE_VIRTUAL)) {
	}
	require 'linux/page-flags.ph';
	eval 'sub put_page_testzero {
	    local($p) = @_;
    	    eval q(({  &BUG_ON( &page_count($p) == 0);  &atomic_dec_and_test(($p)-> &count); }));
	}' unless defined(&put_page_testzero);
	eval 'sub set_page_count {
	    local($p,$v) = @_;
    	    eval q( &atomic_set(($p)-> &count, $v));
	}' unless defined(&set_page_count);
	eval 'sub __put_page {
	    local($p) = @_;
    	    eval q( &atomic_dec(($p)-> &count));
	}' unless defined(&__put_page);
	if(defined(&CONFIG_HUGETLB_PAGE)) {
	} else {
	    eval 'sub page_count {
	        local($p) = @_;
    		eval q( &atomic_read(($p)-> &count));
	    }' unless defined(&page_count);
	}
	eval 'sub NODEZONE_SHIFT {($sizeof{ &page_flags_t}*8-  &MAX_NODES_SHIFT -  &MAX_ZONES_SHIFT);}' unless defined(&NODEZONE_SHIFT);
	eval 'sub NODEZONE {
	    local($node, $zone) = @_;
    	    eval q((($node <<  &ZONES_SHIFT) | $zone));
	}' unless defined(&NODEZONE);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	}
	if(defined( &CONFIG_HIGHMEM)  && !defined( &WANT_PAGE_VIRTUAL)) {
	    eval 'sub HASHED_PAGE_VIRTUAL {1;}' unless defined(&HASHED_PAGE_VIRTUAL);
	}
	if(defined( &WANT_PAGE_VIRTUAL)) {
	    eval 'sub page_address {
	        local($page) = @_;
    		eval q((($page)-> &virtual));
	    }' unless defined(&page_address);
	    eval 'sub set_page_address {
	        local($page, $address) = @_;
    		eval q( &do { ($page)-> &virtual = ($address); }  &while(0));
	    }' unless defined(&set_page_address);
	    eval 'sub page_address_init () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&page_address_init);
	}
	if(defined( &HASHED_PAGE_VIRTUAL)) {
	}
	if(!defined( &HASHED_PAGE_VIRTUAL)  && !defined( &WANT_PAGE_VIRTUAL)) {
	    eval 'sub page_address {
	        local($page) = @_;
    		eval q( &lowmem_page_address($page));
	    }' unless defined(&page_address);
	    eval 'sub set_page_address {
	        local($page, $address) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&set_page_address);
	    eval 'sub page_address_init () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&page_address_init);
	}
	eval 'sub NOPAGE_SIGBUS {( &NULL);}' unless defined(&NOPAGE_SIGBUS);
	eval 'sub NOPAGE_OOM {( (-1));}' unless defined(&NOPAGE_OOM);
	eval 'sub VM_FAULT_OOM {(-1);}' unless defined(&VM_FAULT_OOM);
	eval 'sub VM_FAULT_SIGBUS {0;}' unless defined(&VM_FAULT_SIGBUS);
	eval 'sub VM_FAULT_MINOR {1;}' unless defined(&VM_FAULT_MINOR);
	eval 'sub VM_FAULT_MAJOR {2;}' unless defined(&VM_FAULT_MAJOR);
	eval 'sub offset_in_page {
	    local($p) = @_;
    	    eval q((($p) & ~ &PAGE_MASK));
	}' unless defined(&offset_in_page);
	eval 'sub DEFAULT_SEEKS {2;}' unless defined(&DEFAULT_SEEKS);
	if(defined(&CONFIG_MMU)) {
	}
	eval 'sub VM_MAX_READAHEAD {128;}' unless defined(&VM_MAX_READAHEAD);
	eval 'sub VM_MIN_READAHEAD {16;}' unless defined(&VM_MIN_READAHEAD);
	unless(defined(&CONFIG_DEBUG_PAGEALLOC)) {
	}
	unless(defined(&CONFIG_ARCH_GATE_AREA)) {
	}
    }
}
1;
