require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_QUOTAOPS_)) {
    eval 'sub _LINUX_QUOTAOPS_ {1;}' unless defined(&_LINUX_QUOTAOPS_);
    require 'linux/config.ph';
    require 'linux/smp_lock.ph';
    require 'linux/fs.ph';
    if(defined( &CONFIG_QUOTA)) {
	eval 'sub sb_dquot_ops {( &dquot_operations);}' unless defined(&sb_dquot_ops);
	eval 'sub sb_quotactl_ops {( &vfs_quotactl_ops);}' unless defined(&sb_quotactl_ops);
	eval 'sub DQUOT_SYNC {
	    local($sb) = @_;
    	    eval q( &sync_dquots($sb, -1));
	}' unless defined(&DQUOT_SYNC);
    } else {
	eval 'sub sb_dquot_ops {( &NULL);}' unless defined(&sb_dquot_ops);
	eval 'sub sb_quotactl_ops {( &NULL);}' unless defined(&sb_quotactl_ops);
	eval 'sub sync_dquots_dev {
	    local($dev,$type) = @_;
    	    eval q(( &NULL));
	}' unless defined(&sync_dquots_dev);
	eval 'sub DQUOT_INIT {
	    local($inode) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&DQUOT_INIT);
	eval 'sub DQUOT_DROP {
	    local($inode) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&DQUOT_DROP);
	eval 'sub DQUOT_ALLOC_INODE {
	    local($inode) = @_;
    	    eval q((0));
	}' unless defined(&DQUOT_ALLOC_INODE);
	eval 'sub DQUOT_FREE_INODE {
	    local($inode) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&DQUOT_FREE_INODE);
	eval 'sub DQUOT_SYNC {
	    local($sb) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&DQUOT_SYNC);
	eval 'sub DQUOT_OFF {
	    local($sb) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&DQUOT_OFF);
	eval 'sub DQUOT_TRANSFER {
	    local($inode, $iattr) = @_;
    	    eval q((0));
	}' unless defined(&DQUOT_TRANSFER);
    }
    eval 'sub DQUOT_PREALLOC_BLOCK_NODIRTY {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_PREALLOC_SPACE_NODIRTY($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_PREALLOC_BLOCK_NODIRTY);
    eval 'sub DQUOT_PREALLOC_BLOCK {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_PREALLOC_SPACE($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_PREALLOC_BLOCK);
    eval 'sub DQUOT_ALLOC_BLOCK_NODIRTY {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_ALLOC_SPACE_NODIRTY($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_ALLOC_BLOCK_NODIRTY);
    eval 'sub DQUOT_ALLOC_BLOCK {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_ALLOC_SPACE($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_ALLOC_BLOCK);
    eval 'sub DQUOT_FREE_BLOCK_NODIRTY {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_FREE_SPACE_NODIRTY($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_FREE_BLOCK_NODIRTY);
    eval 'sub DQUOT_FREE_BLOCK {
        local($inode, $nr) = @_;
	    eval q( &DQUOT_FREE_SPACE($inode, (($nr)) << ($inode)-> ($i_sb->{s_blocksize_bits})));
    }' unless defined(&DQUOT_FREE_BLOCK);
}
1;
