require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_USB_H)) {
    eval 'sub __LINUX_USB_H {1;}' unless defined(&__LINUX_USB_H);
    require 'linux/mod_devicetable.ph';
    require 'linux/usb_ch9.ph';
    eval 'sub USB_MAJOR {180;}' unless defined(&USB_MAJOR);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/errno.ph';
	require 'linux/delay.ph';
	require 'linux/interrupt.ph';
	require 'linux/list.ph';
	require 'linux/device.ph';
	require 'linux/fs.ph';
	require 'linux/completion.ph';
	require 'linux/sched.ph';
	eval 'sub to_usb_interface {
	    local($d) = @_;
    	    eval q( &container_of($d, \'struct usb_interface\',  &dev));
	}' unless defined(&to_usb_interface);
	eval 'sub interface_to_usbdev {
	    local($intf) = @_;
    	    eval q( &container_of( ($intf->{dev}->{parent}), \'struct usb_device\',  &dev));
	}' unless defined(&interface_to_usbdev);
	eval 'sub USB_MAXINTERFACES {32;}' unless defined(&USB_MAXINTERFACES);
	eval 'sub usb_get_extra_descriptor {
	    local($ifpoint,$type,$ptr) = @_;
    	    eval q( &__usb_get_extra_descriptor(-> &extra,-> &extralen, $type,$ptr));
	}' unless defined(&usb_get_extra_descriptor);
	eval 'sub to_usb_bus {
	    local($d) = @_;
    	    eval q( &container_of($d, \'struct usb_bus\',  &class_dev));
	}' unless defined(&to_usb_bus);
	eval 'sub USB_MAXCHILDREN {(16);}' unless defined(&USB_MAXCHILDREN);
	eval 'sub to_usb_device {
	    local($d) = @_;
    	    eval q( &container_of($d, \'struct usb_device\',  &dev));
	}' unless defined(&to_usb_device);
	eval 'sub USB_DEVICE_ID_MATCH_DEVICE {( &USB_DEVICE_ID_MATCH_VENDOR |  &USB_DEVICE_ID_MATCH_PRODUCT);}' unless defined(&USB_DEVICE_ID_MATCH_DEVICE);
	eval 'sub USB_DEVICE_ID_MATCH_DEV_RANGE {( &USB_DEVICE_ID_MATCH_DEV_LO |  &USB_DEVICE_ID_MATCH_DEV_HI);}' unless defined(&USB_DEVICE_ID_MATCH_DEV_RANGE);
	eval 'sub USB_DEVICE_ID_MATCH_DEVICE_AND_VERSION {( &USB_DEVICE_ID_MATCH_DEVICE |  &USB_DEVICE_ID_MATCH_DEV_RANGE);}' unless defined(&USB_DEVICE_ID_MATCH_DEVICE_AND_VERSION);
	eval 'sub USB_DEVICE_ID_MATCH_DEV_INFO {( &USB_DEVICE_ID_MATCH_DEV_CLASS |  &USB_DEVICE_ID_MATCH_DEV_SUBCLASS |  &USB_DEVICE_ID_MATCH_DEV_PROTOCOL);}' unless defined(&USB_DEVICE_ID_MATCH_DEV_INFO);
	eval 'sub USB_DEVICE_ID_MATCH_INT_INFO {( &USB_DEVICE_ID_MATCH_INT_CLASS |  &USB_DEVICE_ID_MATCH_INT_SUBCLASS |  &USB_DEVICE_ID_MATCH_INT_PROTOCOL);}' unless defined(&USB_DEVICE_ID_MATCH_INT_INFO);
	eval 'sub USB_DEVICE {
	    local($vend,$prod) = @_;
    	    eval q(. &match_flags =  &USB_DEVICE_ID_MATCH_DEVICE, . &idVendor = ($vend), . &idProduct = ($prod));
	}' unless defined(&USB_DEVICE);
	eval 'sub USB_DEVICE_VER {
	    local($vend,$prod,$lo,$hi) = @_;
    	    eval q(. &match_flags =  &USB_DEVICE_ID_MATCH_DEVICE_AND_VERSION, . &idVendor = ($vend), . &idProduct = ($prod), . &bcdDevice_lo = ($lo), . &bcdDevice_hi = ($hi));
	}' unless defined(&USB_DEVICE_VER);
	eval 'sub USB_DEVICE_INFO {
	    local($cl,$sc,$pr) = @_;
    	    eval q(. &match_flags =  &USB_DEVICE_ID_MATCH_DEV_INFO, . &bDeviceClass = ($cl), . &bDeviceSubClass = ($sc), . &bDeviceProtocol = ($pr));
	}' unless defined(&USB_DEVICE_INFO);
	eval 'sub USB_INTERFACE_INFO {
	    local($cl,$sc,$pr) = @_;
    	    eval q(. &match_flags =  &USB_DEVICE_ID_MATCH_INT_INFO, . &bInterfaceClass = ($cl), . &bInterfaceSubClass = ($sc), . &bInterfaceProtocol = ($pr));
	}' unless defined(&USB_INTERFACE_INFO);
	eval 'sub to_usb_driver {
	    local($d) = @_;
    	    eval q( &container_of($d, \'struct usb_driver\',  &driver));
	}' unless defined(&to_usb_driver);
	eval 'sub URB_SHORT_NOT_OK {0x1;}' unless defined(&URB_SHORT_NOT_OK);
	eval 'sub URB_ISO_ASAP {0x2;}' unless defined(&URB_ISO_ASAP);
	eval 'sub URB_NO_TRANSFER_DMA_MAP {0x4;}' unless defined(&URB_NO_TRANSFER_DMA_MAP);
	eval 'sub URB_NO_SETUP_DMA_MAP {0x8;}' unless defined(&URB_NO_SETUP_DMA_MAP);
	eval 'sub URB_ASYNC_UNLINK {0x10;}' unless defined(&URB_ASYNC_UNLINK);
	eval 'sub URB_NO_FSBR {0x20;}' unless defined(&URB_NO_FSBR);
	eval 'sub URB_ZERO_PACKET {0x40;}' unless defined(&URB_ZERO_PACKET);
	eval 'sub URB_NO_INTERRUPT {0x80;}' unless defined(&URB_NO_INTERRUPT);
	eval 'sub usb_put_urb { &usb_free_urb;}' unless defined(&usb_put_urb);
	eval 'sub HAVE_USB_BUFFERS {1;}' unless defined(&HAVE_USB_BUFFERS);
	if(0) {
	}
	if(0) {
	}
	eval 'sub USB_CTRL_GET_TIMEOUT {5;}' unless defined(&USB_CTRL_GET_TIMEOUT);
	eval 'sub USB_CTRL_SET_TIMEOUT {5;}' unless defined(&USB_CTRL_SET_TIMEOUT);
	eval 'sub PIPE_ISOCHRONOUS {0;}' unless defined(&PIPE_ISOCHRONOUS);
	eval 'sub PIPE_INTERRUPT {1;}' unless defined(&PIPE_INTERRUPT);
	eval 'sub PIPE_CONTROL {2;}' unless defined(&PIPE_CONTROL);
	eval 'sub PIPE_BULK {3;}' unless defined(&PIPE_BULK);
	eval 'sub usb_maxpacket {
	    local($dev, $pipe, $out) = @_;
    	    eval q(($out ? ($dev)-> $epmaxpacketout[ &usb_pipeendpoint($pipe)] : ($dev)-> &epmaxpacketin [ &usb_pipeendpoint($pipe)] ));
	}' unless defined(&usb_maxpacket);
	eval 'sub usb_pipein {
	    local($pipe) = @_;
    	    eval q((($pipe) &  &USB_DIR_IN));
	}' unless defined(&usb_pipein);
	eval 'sub usb_pipeout {
	    local($pipe) = @_;
    	    eval q((! &usb_pipein($pipe)));
	}' unless defined(&usb_pipeout);
	eval 'sub usb_pipedevice {
	    local($pipe) = @_;
    	    eval q(((($pipe) >> 8) & 0x7f));
	}' unless defined(&usb_pipedevice);
	eval 'sub usb_pipeendpoint {
	    local($pipe) = @_;
    	    eval q(((($pipe) >> 15) & 0xf));
	}' unless defined(&usb_pipeendpoint);
	eval 'sub usb_pipetype {
	    local($pipe) = @_;
    	    eval q(((($pipe) >> 30) & 3));
	}' unless defined(&usb_pipetype);
	eval 'sub usb_pipeisoc {
	    local($pipe) = @_;
    	    eval q(( &usb_pipetype(($pipe)) ==  &PIPE_ISOCHRONOUS));
	}' unless defined(&usb_pipeisoc);
	eval 'sub usb_pipeint {
	    local($pipe) = @_;
    	    eval q(( &usb_pipetype(($pipe)) ==  &PIPE_INTERRUPT));
	}' unless defined(&usb_pipeint);
	eval 'sub usb_pipecontrol {
	    local($pipe) = @_;
    	    eval q(( &usb_pipetype(($pipe)) ==  &PIPE_CONTROL));
	}' unless defined(&usb_pipecontrol);
	eval 'sub usb_pipebulk {
	    local($pipe) = @_;
    	    eval q(( &usb_pipetype(($pipe)) ==  &PIPE_BULK));
	}' unless defined(&usb_pipebulk);
	eval 'sub usb_gettoggle {
	    local($dev, $ep, $out) = @_;
    	    eval q(((($dev)-> $toggle[$out] >> ($ep)) & 1));
	}' unless defined(&usb_gettoggle);
	eval 'sub usb_dotoggle {
	    local($dev, $ep, $out) = @_;
    	    eval q((($dev)-> $toggle[$out] ^= (1<< ($ep))));
	}' unless defined(&usb_dotoggle);
	eval 'sub usb_settoggle {
	    local($dev, $ep, $out, $bit) = @_;
    	    eval q((($dev)-> $toggle[$out] = (($dev)-> $toggle[$out] & ~(1<< ($ep))) | (($bit) << ($ep))));
	}' unless defined(&usb_settoggle);
	eval 'sub usb_endpoint_running {
	    local($dev, $ep, $out) = @_;
    	    eval q((($dev)-> $halted[$out] &= ~(1<< ($ep))));
	}' unless defined(&usb_endpoint_running);
	eval 'sub usb_endpoint_halted {
	    local($dev, $ep, $out) = @_;
    	    eval q((($dev)-> $halted[$out] & (1<< ($ep))));
	}' unless defined(&usb_endpoint_halted);
	eval 'sub usb_sndctrlpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_CONTROL << 30) |  &__create_pipe($dev,$endpoint)));
	}' unless defined(&usb_sndctrlpipe);
	eval 'sub usb_rcvctrlpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_CONTROL << 30) |  &__create_pipe($dev,$endpoint) |  &USB_DIR_IN));
	}' unless defined(&usb_rcvctrlpipe);
	eval 'sub usb_sndisocpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_ISOCHRONOUS << 30) |  &__create_pipe($dev,$endpoint)));
	}' unless defined(&usb_sndisocpipe);
	eval 'sub usb_rcvisocpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_ISOCHRONOUS << 30) |  &__create_pipe($dev,$endpoint) |  &USB_DIR_IN));
	}' unless defined(&usb_rcvisocpipe);
	eval 'sub usb_sndbulkpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_BULK << 30) |  &__create_pipe($dev,$endpoint)));
	}' unless defined(&usb_sndbulkpipe);
	eval 'sub usb_rcvbulkpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_BULK << 30) |  &__create_pipe($dev,$endpoint) |  &USB_DIR_IN));
	}' unless defined(&usb_rcvbulkpipe);
	eval 'sub usb_sndintpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_INTERRUPT << 30) |  &__create_pipe($dev,$endpoint)));
	}' unless defined(&usb_sndintpipe);
	eval 'sub usb_rcvintpipe {
	    local($dev,$endpoint) = @_;
    	    eval q((( &PIPE_INTERRUPT << 30) |  &__create_pipe($dev,$endpoint) |  &USB_DIR_IN));
	}' unless defined(&usb_rcvintpipe);
	if(defined(&DEBUG)) {
	    eval 'sub dbg {( &format,  &arg...)  &printk( &KERN_DEBUG "%s: "  &format "\\n" ,  &__FILE__ ,   &arg);}' unless defined(&dbg);
	} else {
	    eval 'sub dbg {( &format,  &arg...)  &do {}  &while (0);}' unless defined(&dbg);
	}
	eval 'sub err {( &format,  &arg...)  &printk( &KERN_ERR "%s: "  &format "\\n" ,  &__FILE__ ,   &arg);}' unless defined(&err);
	eval 'sub info {( &format,  &arg...)  &printk( &KERN_INFO "%s: "  &format "\\n" ,  &__FILE__ ,   &arg);}' unless defined(&info);
	eval 'sub warn {( &format,  &arg...)  &printk( &KERN_WARNING "%s: "  &format "\\n" ,  &__FILE__ ,   &arg);}' unless defined(&warn);
    }
}
1;
