require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_QUOTA_H)) {
    eval 'sub _SYS_QUOTA_H {1;}' unless defined(&_SYS_QUOTA_H);
    require 'features.ph';
    require 'sys/types.ph';
    eval 'sub MAXQUOTAS {2;}' unless defined(&MAXQUOTAS);
    eval 'sub USRQUOTA {0;}' unless defined(&USRQUOTA);
    eval 'sub GRPQUOTA {1;}' unless defined(&GRPQUOTA);
    eval 'sub INITQFNAMES {{ "user", "group", "undefined", };}' unless defined(&INITQFNAMES);
    eval 'sub INITQMAGICS {{ 0xd9c01f11, 0xd9c01927 };}' unless defined(&INITQMAGICS);
    eval 'sub QUOTABLOCK_BITS {10;}' unless defined(&QUOTABLOCK_BITS);
    eval 'sub QUOTABLOCK_SIZE {(1<<  &QUOTABLOCK_BITS);}' unless defined(&QUOTABLOCK_SIZE);
    eval 'sub qb2kb {
        local($x) = @_;
	    eval q((($x) << ( &QUOTABLOCK_BITS-10)));
    }' unless defined(&qb2kb);
    eval 'sub kb2qb {
        local($x) = @_;
	    eval q((($x) >> ( &QUOTABLOCK_BITS-10)));
    }' unless defined(&kb2qb);
    eval 'sub toqb {
        local($x) = @_;
	    eval q(((($x) +  &QUOTABLOCK_SIZE - 1) >>  &QUOTABLOCK_BITS));
    }' unless defined(&toqb);
    eval 'sub SUBCMDMASK {0xff;}' unless defined(&SUBCMDMASK);
    eval 'sub SUBCMDSHIFT {8;}' unless defined(&SUBCMDSHIFT);
    eval 'sub QCMD {
        local($cmd, $type) = @_;
	    eval q(((($cmd) <<  &SUBCMDSHIFT) | (($type) &  &SUBCMDMASK)));
    }' unless defined(&QCMD);
    eval 'sub Q_6_5_QUOTAON {0x100;}' unless defined(&Q_6_5_QUOTAON);
    eval 'sub Q_6_5_QUOTAOFF {0x200;}' unless defined(&Q_6_5_QUOTAOFF);
    eval 'sub Q_6_5_SYNC {0x600;}' unless defined(&Q_6_5_SYNC);
    eval 'sub Q_SYNC {0x800001;}' unless defined(&Q_SYNC);
    eval 'sub Q_QUOTAON {0x800002;}' unless defined(&Q_QUOTAON);
    eval 'sub Q_QUOTAOFF {0x800003;}' unless defined(&Q_QUOTAOFF);
    eval 'sub Q_GETFMT {0x800004;}' unless defined(&Q_GETFMT);
    eval 'sub Q_GETINFO {0x800005;}' unless defined(&Q_GETINFO);
    eval 'sub Q_SETINFO {0x800006;}' unless defined(&Q_SETINFO);
    eval 'sub Q_GETQUOTA {0x800007;}' unless defined(&Q_GETQUOTA);
    eval 'sub Q_SETQUOTA {0x800008;}' unless defined(&Q_SETQUOTA);
    eval 'sub QIF_BLIMITS {1;}' unless defined(&QIF_BLIMITS);
    eval 'sub QIF_SPACE {2;}' unless defined(&QIF_SPACE);
    eval 'sub QIF_ILIMITS {4;}' unless defined(&QIF_ILIMITS);
    eval 'sub QIF_INODES {8;}' unless defined(&QIF_INODES);
    eval 'sub QIF_BTIME {16;}' unless defined(&QIF_BTIME);
    eval 'sub QIF_ITIME {32;}' unless defined(&QIF_ITIME);
    eval 'sub QIF_LIMITS {( &QIF_BLIMITS |  &QIF_ILIMITS);}' unless defined(&QIF_LIMITS);
    eval 'sub QIF_USAGE {( &QIF_SPACE |  &QIF_INODES);}' unless defined(&QIF_USAGE);
    eval 'sub QIF_TIMES {( &QIF_BTIME |  &QIF_ITIME);}' unless defined(&QIF_TIMES);
    eval 'sub QIF_ALL {( &QIF_LIMITS |  &QIF_USAGE |  &QIF_TIMES);}' unless defined(&QIF_ALL);
    eval 'sub IIF_BGRACE {1;}' unless defined(&IIF_BGRACE);
    eval 'sub IIF_IGRACE {2;}' unless defined(&IIF_IGRACE);
    eval 'sub IIF_FLAGS {4;}' unless defined(&IIF_FLAGS);
    eval 'sub IIF_ALL {( &IIF_BGRACE |  &IIF_IGRACE |  &IIF_FLAGS);}' unless defined(&IIF_ALL);
    eval 'sub QFMT_VFS_OLD {1;}' unless defined(&QFMT_VFS_OLD);
    eval 'sub QFMT_VFS_V0 {2;}' unless defined(&QFMT_VFS_V0);
    eval 'sub V1_DQF_RSQUASH {1;}' unless defined(&V1_DQF_RSQUASH);
    require 'sys/ioctl.ph';
    unless(defined(&FIOQSIZE)) {
	if(defined( &__alpha__) || defined( &__powerpc__) || defined( &__sh__) || defined( &__sparc__) || defined( &__sparc64__)) {
	    eval 'sub FIOQSIZE { &_IOR(ord(\'f\'), 128,  &loff_t);}' unless defined(&FIOQSIZE);
	}
 elsif(defined( &__arm__) || defined( &__mc68000__) || defined( &__s390__)) {
	    eval 'sub FIOQSIZE {0x545e;}' unless defined(&FIOQSIZE);
	}
 elsif(defined( &__i386__) || defined( &__i486__) || defined( &__i586__) || defined( &__ia64__) || defined( &__parisc__) || defined( &__cris__) || defined( &__hppa__)) {
	    eval 'sub FIOQSIZE {0x5460;}' unless defined(&FIOQSIZE);
	}
 elsif(defined( &__mips__) || defined( &__mips64__)) {
	    eval 'sub FIOQSIZE {0x6667;}' unless defined(&FIOQSIZE);
	}
    }
}
1;
